/*
      ...
*/

#include "config.h"
#include "version.h"
#include <stdio.h>
#include <syslog.h>	//     syslog
#include <signal.h>	
#include <unistd.h>	//   
#include <fcntl.h>	//   creat(2)
#include <string.h>	//   str*()
#include <sys/types.h>
#include <sys/param.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <errno.h>
#if defined (BSD) && !_POSIX_SOURCE
	#include <sys/dir.h>
	typedef struct direct Dirent;
#else
	#include <dirent.h>
	typedef struct dirent Dirent;
#endif


int	findmail	(char *indir,short int);
int	pkt_process	(char *mailn);
int	scanlock	(char *lock);
int	system		(char *);

int errno;
static char pkt_run[255];
static char packet_run[255];
static char tic_run[255];
static char mail_run[255];
static char news_run[255];
static char fidog_run[255];

int main (int argc, char **argv)
{
	int FPID;
	int i=0;
	char spid[6];

	//     
    if (getppid() !=1) {
    	signal (SIGTTOU, SIG_IGN);
	signal (SIGTTIN, SIG_IGN);
	signal (SIGTSTP, SIG_IGN);
	if (fork() != 0)
	    exit(0);
	    setsid();
	}

	//---------------------------------------------------------------------
	//   PID-  scanlock.
    sprintf (spid, "%d", getpid());
    if(scanlock(PID_FILE) == 1) {
	openlog("tossd", LOG_CONS, LOG_DAEMON);
	syslog(LOG_ERR, "Error! PidFile %s exist. I'm die!", PID_FILE);
	closelog();
	exit(1);
    }
	//  PID-   ...
    FPID = open (PID_FILE, O_WRONLY | O_CREAT, 0600);
    write (FPID, spid, strlen(spid));
    close (FPID);

    openlog("tossd", LOG_PID | LOG_CONS, LOG_DAEMON);
    syslog(LOG_INFO, "Starting...%d.%d%s-%s",VER, SUBVER, UPD, DATE);
    closelog();

    chdir(INB_PRO);

    sprintf(pkt_run, "%s -%d %s %s",NICE_BIN, NICE, RUN_PKT, RUN_PKT_FLAG);
    sprintf(packet_run, "%s -%d %s %s",NICE_BIN, NICE, RUN_PACKET ,RUN_PACKET_FLAG);
    sprintf(tic_run, "%s -%d %s %s",NICE_BIN, NICE, RUN_TIC, RUN_PACKET_FLAG);
    sprintf(mail_run, "%s -%d %s",NICE_BIN, NICE, RUN_MAIL);
    sprintf(news_run, "%s -%d %s",NICE_BIN, NICE, RUN_NEWS);
    sprintf(fidog_run, "%s -%d %s",NICE_BIN, NICE, SEND_FIDOGATE);

    while (1) {
//  Protected Inbound
	findmail(INB_PRO,0);
//  Unprotected Inbound
	findmail(INB_UNP,0);
// 
	sleep(SLEEP_TIME);
//   
	if (SCAN_OUT==i) {
	    findmail(OUT_MAIL,1);
	    findmail(OUT_NEWS,2);
	    i=0;
	}
	i++;
    }
}

int findmail(char *indir,short int mode) {
    
    char *file;
    DIR *dir;
    struct dirent *dirp;
    char mailn[255];

    dir=opendir(indir); //    indir
    while ((dirp = readdir(dir)))
    	if ((strlen(dirp->d_name) == 12)) {
	    if (strncasecmp(dirp->d_name+8,".pkt",4) == 0) { //  pkt'
	        file = dirp->d_name;
		//     syslog
	        sprintf(mailn, "%s/%s", indir, file);
	        openlog("tossd", LOG_PID | LOG_CONS, LOG_DAEMON);
	        syslog(LOG_ERR, "Found pkt file %s!",mailn);
	        closelog();
		//      
	        switch (mode) {
		    case 0:
			pkt_process (mailn);
			break;
		    case 1:
			system (mail_run);
			break;
		    case 2:
			system (fidog_run);
			system (news_run);
			break;
		}
		return 1;
	        }
		//    Protected Inbound
	    if (strcmp(indir,INB_PRO)==0) {
		//   tic 
		if (strncasecmp(dirp->d_name+8,".tic",4) == 0) {
		    file = dirp->d_name;
		    openlog("tossd", LOG_PID | LOG_CONS, LOG_DAEMON);
		    syslog(LOG_ERR, "Found tic file %s in INB_PRO!",file);
		    closelog();
		    if ((scanlock(LOCK_RUN_TIC))==0)
			system (tic_run);
		    return 1;
		}
		//    
	        if ((strncasecmp(dirp->d_name+8,".s",2) == 0) ||
	    	    (strncasecmp(dirp->d_name+8,".m",2) == 0) ||
	    	    (strncasecmp(dirp->d_name+8,".t",2) == 0) ||
		    (strncasecmp(dirp->d_name+8,".w",2) == 0) ||
		    (strncasecmp(dirp->d_name+8,".f",2) == 0)) {
		    file = dirp->d_name;
		    openlog("tossd", LOG_PID | LOG_CONS, LOG_DAEMON);
		    syslog(LOG_ERR, "Found packet %s in INB_PRO!",file);
		    syslog(LOG_ERR, "%s",packet_run);
		    closelog();
		    if ((scanlock(LOCK_RUN_PACKET))==0)
			system (packet_run);
		    return 1;
		}
	    }
	}
    closedir(dir);
    return 1;
}

int pkt_process (char *mailn) {
    struct stat statv;
    
	if ( stat(mailn, &statv) ) 
    	    return 0;	//   -  .  
	if ( statv.st_size ==0 ) {
	    openlog("tossd", LOG_PID | LOG_CONS, LOG_DAEMON);
	    syslog(LOG_ERR, "Killing file: %s, size=0!", mailn);
	    closelog();
	    remove (mailn);	//   0- !
	}
	else
	    if ((scanlock(LOCK_RUN_PKT)) != 1) {
	    //   PID'  ,   .
	    openlog("tossd", LOG_PID | LOG_CONS, LOG_DAEMON);
	    syslog(LOG_ERR, "runing: %s", pkt_run);
	    closelog();
	    system (pkt_run);
	    }
return 1;
}

//  PID .
int scanlock (char *lock) {

    char buff[32];
    pid_t pid;
    FILE *fp;

    if((fp = fopen(lock,"r")))     // PID  ...
    {
    	//   pid  PID .
	fgets(buff,sizeof(buff),fp);
		pid=(pid_t) atoi(buff);
	//  c pid  ...
        if(kill(pid, 0) == -1 && errno == ESRCH)
        {	//   syslog
		openlog("tossd", LOG_PID | LOG_CONS, LOG_DAEMON);
    		syslog(LOG_ERR, "$WARNING: stale lock file %s
				    (pid = %d) found", lock, pid);
		closelog();
		fclose(fp);
		//   PID .
	        if ((unlink(lock)) == -1) {
		    //   syslog
		    openlog("tossd", LOG_PID | LOG_CONS, LOG_DAEMON);
		    syslog(LOG_ERR, "can't unlink lock %s",lock);
		    closelog();
		    //  .
		    sleep(60);
		return 1;
		
		}
	        else return 0;
        }
        else return 1;
    }
    else return 0;
}